



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Node爬虫之初体验</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Node爬虫之初体验</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 16:37:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>记得之前就听说过爬虫，个人初步理解就是从网页中抓取一些有用的数据，存储到本地，今天就当是小牛试刀，拿来溜溜......</p>
<p><strong>实现需求</strong>： <strong>抓取课程数据，输入url后并在浏览器端以一定的数据格式显示出来（如下图所示）</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/819169/201703/819169-20170314221822026-194142245.png" /></p>
<p><strong>实现需求需用到的Node库介绍</strong></p>
<p>cheerio(<a href="https://github.com/cheeriojs/cheerio" rel="external nofollow noreferrer">https://github.com/cheeriojs/cheerio</a>&nbsp;) &nbsp;可以理解成一个<strong> Node.js 版的 jquery</strong>，用来从网页中以 <strong>css selector</strong> <strong>取数据，使用方式跟 jquery</strong> 一样一样的。</p>
<p>superagent(<a href="http://visionmedia.github.io/superagent/" rel="external nofollow noreferrer">http://visionmedia.github.io/superagent/</a>&nbsp;)&nbsp;是个轻量的的 http 方面的库，是nodejs里一个非常方便的<strong>客户端请求代理模块</strong>，当我们需要进行 <strong>get 、 post 、 head 等网络请求时</strong>。</p>
<p>express(<a href="http://www.expressjs.com.cn/starter/installing.html" rel="external nofollow noreferrer">http://www.expressjs.com.cn/starter/</a>)&nbsp;是一个基于 Node.js 平台的极简、灵活的 web 应用开发框架,路由、express生成器、静态文件等。</p>
<p><strong>实现需求源代码如下</strong></p>
<p>package.json</p>
<p>npm init生成package.json配置文件</p>
<p>devDependencies、dependencies&nbsp;依赖组件</p>
<div>
<pre class="prettyprint linenums">{<br />
  "name": "package.json",<br />
  "version": "1.0.0",<br />
  "description": "",<br />
  "main": "app.js",<br />
  "dependencies": {<br />
    "cheerio": "^0.22.0"<br />
  },<br />
  "devDependencies": {<br />
    "express": "^4.15.2",<br />
    "superagent": "^3.5.0"<br />
  },<br />
  "scripts": {<br />
    "test": "echo \"Error: no test specified\" &amp;&amp; exit 1"<br />
  },<br />
  "author": "Avenstar",<br />
  "license": "ISC"<br />
}</pre>
</div>
<p>crawler.js</p>
<div>
<pre class="prettyprint linenums">var express = require('express'),<br />
    app = express(),//基于WEB平台的开发框架<br />
    superagent = require("superagent"),//处理服务端/客户端的http请求<br />
    cheerio=require('cheerio');//一个 Node.js 版的 jquery，用来从网页中以 css selector 取数据，使用方式跟 jquery 一样<br />
var pathUrl='http://www.imooc.com/learn/348';

/*=========================================================================<br />
|抓取data数据结构如下<br />
|    var courseData = [{<br />
|           chapterTitle:'',<br />
|            videos:[{<br />
|              title:'',<br />
|               id:''<br />
|            }]<br />
|     }]<br />
*==========================================================================*/<br />
function printCourseInfo(courseData){<br />
    courseData.forEach(function(item){<br />
        var chapterTitle=item.chapterTitle;<br />
        console.log(chapterTitle+'\n');<br />
        item.videos.forEach(function(video){<br />
            console.log(' 【'+video.id+'】'+video.title+'\n');<br />
        })<br />
    });<br />
}<br />
/*==========================================================================<br />
|   分析从网页里抓取到的数据<br />
==========================================================================*/<br />
function filterChapter(html){<br />
    var courseData=[];<br />
    var $=cheerio.load(html);<br />
    var chapters=$('.chapter');<br />
    chapters.each(function(item){<br />
        var chapter=$(this);<br />
        var chapterTitle=chapter.find('strong').text().replace(/(\s*)/g,''); //找到章节标题<br />
        var videos=chapter.find('.video').children('li');

        var chapterData={<br />
            chapterTitle:chapterTitle,<br />
            videos:[]<br />
        };

        //videos<br />
        videos.each(function(item){<br />
            var $that = $(this),<br />
                video=$that.find('.J-media-item'),<br />
                title=video.text().replace(/(\s*)/g,'');<br />
                id=video.attr('href').split('/video')[1].replace(/(\s*)/g,'').replace('/','');<br />
            chapterData.videos.push({<br />
                title:title,<br />
                id:id<br />
            })<br />
        })<br />
        courseData.push(chapterData);<br />
    });<br />
    return courseData;<br />
}<br />
/*==========================================================================<br />
| GET method route<br />
===========================================================================*/<br />
app.get('/', function(request, respones){<br />
   //处理服务端/客户端的http请求<br />
   superagent.get(pathUrl).end(function(error, sres){<br />
       //error<br />
       if(error){<br />
          return next(err);<br />
       }<br />
       //抓取https网址html<br />
       var html = sres.text;<br />
       var courseData=filterChapter(html);<br />
       //打印<br />
       printCourseInfo(courseData);<br />
       //respones<br />
       respones.send((courseData));<br />
    })<br />
})<br />
/*==========================================================================<br />
| listening at port<br />
===========================================================================*/<br />
app.listen(9090, function(){<br />
    console.log('app is listening at port 9090');<br />
});
</pre>
</div>
<p>资料参考</p>
<p>　http://www.imooc.com/video/7965</p>
<p>http://www.cnblogs.com/coco1s/p/4954063.html</p>
<p>https://github.com/alsotang/node-lessons</p>
<div>
<p>作者：Avenstar</p>
<p>出处：<a href="http://www.cnblogs.com/zjf-1992/p/6548220.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zjf-1992/p/6548220.html</a></p>
<p>关于作者：专注于前端开发</p>
<p>本文版权归作者所有,转载请标明原文链接</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zrx9e.html">【C&num;代码实战】群蚁算法理论与实践全攻略&mdash;&mdash;旅行商等路径优化问题的新方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k12539.html">javascript深入理解js闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy3y5d8.html">document&period;body&period;clientHeight 和 document&period;documentElement&period;clientHeight的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0ll1q.html">mac svn client 设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdloy9.html">HttpServletRequest&sol;HttpServletResponse乱码问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2edy9.html">The type or namespace name &amp;&num;39&semi;&ast;&ast;&ast;&ast;&amp;&num;39&semi; could not be found &lpar;are you missing a using directive or an assembly reference</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yedenq.html">SQL1-&lpar;增删改查、常用函数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd3ggz9.html">为Play初学者准备的Scala基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7dlv8.html">Mybatis内批量插入Oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kg5e59.html">three&period;js 使用OrbitControls&period;js自由视角观察</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy515xq.html">asp&period;net结合html使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r3pjo9.html">Codeforces 1079 E - The Unbearable Lightness of Weights</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv7jyz8.html">&lpar;转&rpar;Python3入门之线程threading常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/963jznn9.html">VS编程，WPF中，获取鼠标相对于当前屏幕坐标的一种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko1l05q.html">node&period;js 安装 测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx205pv8.html">面向对象设计原则三：里氏替换原则（LSP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e01dwzq.html">【转】javascript 执行环境，变量对象，作用域链</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kmj3m59.html">SAP S&sol;4HANA extensibility扩展原理介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jeel608.html">JS作用域-面向对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dj56n8.html">OPENCV下SIFT算法使用方法笔记</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyyykndq.html">shell编程基础&lpar;三&rpar;&colon; 位置参数与shell脚本的输入输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyyzgjq.html">Redis学习笔记（3）-XShell连接CentOSMini，并安装Redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rr0458.html">集成腾讯位置服务到webapi</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyydp19.html">ASP&period;NET Core中的Startup类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvv71k8.html">Linux 系统的安装 （最全收集）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9603jry9.html">什么是Docker Volume&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyv1v2q.html">js 每到达5次换一行</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvnjn38.html">js 判断数组中是否有某值</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4my5k9.html">es6 语法 （正则扩展）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwpd5k8.html">jQuery插件开发进阶</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
